Subject: bug#63740: closed (bug#63740: broken and questionable attribute normalisation in xml.el)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 30 May 2023 15:51:02 +0000

Your bug report

#63740: broken and questionable attribute normalisation in xml.el

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
63740: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=63740
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: bug#63740: broken and questionable attribute normalisation in xml.el
From: Mattias Engdegård <[email-masked]>
To: [email-masked]
Date: Tue, 30 May 2023 17:50:01 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

I decided that the attempt to collapse whitespace in attributes is wrong and removed the ineffective attempt to do so in 9ae212fb1e. Bug closed.

Subject: broken and questionable attribute normalisation in xml.el
From: Mattias Engdegård <[email-masked]>
To: Emacs Bug Report <[email-masked]>
Cc: Juanma Barranquero <[email-masked]>, "Mark A. Hershberger" <[email-masked]>
Date: Fri, 26 May 2023 17:14:53 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

In `xml-parse-attlist`, we see:

      ;; Multiple whitespace characters should be replaced with a single one
      ;; in the attributes
      (let ((string (match-string-no-properties 1)))
	(replace-regexp-in-string "\\s-\\{2,\\}" " " string)
        ...

The call to `replace-regexp-in-string` is of course useless and there is now a compiler warning telling us, which is how this came to light.

However, should we really collapse whitespace here? If I'm reading the spec correctly, it's not done for CDATA attributes and we have no reason to believe any other type, do we?

I'm no XML expert but it looks like the code is correct and we can just remove the call to `replace-regexp-in-string` (and the misleading comment). Or?